var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useEffect, useState } from 'react';
import { FormBuilder } from '../../../components/FormBuilder';
import { ValidationEventType } from '../../../models/validation/ValidationEventType';
import { ValidationMark } from '../../../models/validation/ValidationMark';
import React from "react";
import { FormBuilderListEditorType } from '../../../interfaces/lists/IFormBuilderListEditorConfig';
import { IFormBuilderListMenuItemSelectionMode } from '../../../interfaces/lists/IFormBuilderListMenuConfig';
const wrapValues = (values) => values === null || values === void 0 ? void 0 : values.map(_ => { return { value: _ }; });
const unwrapValues = (fakeItems) => fakeItems === null || fakeItems === void 0 ? void 0 : fakeItems.map(_ => _.value);
export const DynamicArrayField = (props) => {
    var _a;
    const [items, setItems] = useState((_a = wrapValues(props.value)) !== null && _a !== void 0 ? _a : []);
    useEffect(() => { var _a; return setItems((_a = wrapValues(props.value)) !== null && _a !== void 0 ? _a : []); }, [props.value]);
    const getSchema = () => {
        var _a;
        var schema = {
            options: {
                validation: {
                    ignoreValidation: false,
                    validationRules: {
                        value: { id: "required", validationMark: ValidationMark.Required, validationRule: (item) => item.value != null && item.value != "", validationMessage: "Value must be specified", validateOn: ValidationEventType.Blur | ValidationEventType.Manual },
                    }
                },
                properties: {
                    value: { propertyType: (_a = props.config) === null || _a === void 0 ? void 0 : _a.propertyType, displayName: "Value", config: { resizable: true } },
                }
            }
        };
        return schema;
    };
    const onChange = (fakeItems) => {
        const values = unwrapValues(fakeItems);
        props.onChange(values);
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(FormBuilder, { item: items, schemaConfig: { schemaProvider: { key: "fakeit", getSchema: () => __awaiter(void 0, void 0, void 0, function* () { return getSchema(); }) } }, listProps: {
                config: {
                    itemIdentifier: (item) => { var _a; return (_a = item === null || item === void 0 ? void 0 : item.value) === null || _a === void 0 ? void 0 : _a.toString(); },
                    multiSelect: true,
                    onItemsChange: (fakeItems) => onChange(fakeItems),
                },
                editorConfig: {
                    title: item => "Item",
                    containerOptions: {
                        type: FormBuilderListEditorType.Dialog
                    }
                },
                menuConfig: {
                    actions: (newItem, editItem, deleteItems) => ([
                        { title: "New", iconName: "Add", selectionMode: IFormBuilderListMenuItemSelectionMode.None | IFormBuilderListMenuItemSelectionMode.Single | IFormBuilderListMenuItemSelectionMode.Multi, action: () => newItem() },
                        { title: "Edit", iconName: "Edit", selectionMode: IFormBuilderListMenuItemSelectionMode.Single, action: () => editItem() },
                        { title: "Delete", iconName: "Delete", selectionMode: IFormBuilderListMenuItemSelectionMode.Single | IFormBuilderListMenuItemSelectionMode.Multi, action: () => deleteItems() },
                    ]),
                }
            }, overrideSchema: getSchema() })));
};
//# sourceMappingURL=DynamicArrayField.js.map